| Flutter Impeller |

Public Member Functions | List of all members
impeller::FillRectGeometry Class Referencefinal

`#include <rect_geometry.h>`

Inheritance diagram for impeller::FillRectGeometry:

## Public Member Functions
| FillRectGeometry (Rect rect)
| ~FillRectGeometry () override
bool | CoversArea (const Matrix &transform, const Rect &rect) const override
| Determines if this geometry, transformed by the given `transform`, will completely cover all surface area of the given `rect`. More...
bool | IsAxisAlignedRect () const override
GeometryResult | GetPositionBuffer (const ContentContext &renderer, const Entity &entity, RenderPass &pass) const override
std::optional< Rect > | GetCoverage (const Matrix &transform) const override
Public Member Functions inherited from impeller::Geometry
virtual | ~Geometry ()
virtual GeometryResult::Mode | GetResultMode () const
virtual bool | CanApplyMaskFilter () const
virtual Scalar | ComputeAlphaCoverage (const Matrix &transform) const

## Additional Inherited Members
Static Public Member Functions inherited from impeller::Geometry
static std::unique_ptr< Geometry > | MakeFillPath (const flutter::DlPath &path, std::optional< Rect > inner_rect=std::nullopt)
static std::unique_ptr< Geometry > | MakeStrokePath (const flutter::DlPath &path, const StrokeParameters &stroke={})
static std::unique_ptr< Geometry > | MakeCover ()
static std::unique_ptr< Geometry > | MakeRect (const Rect &rect)
static std::unique_ptr< Geometry > | MakeOval (const Rect &rect)
static std::unique_ptr< Geometry > | MakeLine (const Point &p0, const Point &p1, const StrokeParameters &stroke)
static std::unique_ptr< Geometry > | MakeCircle (const Point &center, Scalar radius)
static std::unique_ptr< Geometry > | MakeStrokedCircle (const Point &center, Scalar radius, Scalar stroke_width)
static std::unique_ptr< Geometry > | MakeFilledArc (const Rect &oval_bounds, Degrees start, Degrees sweep, bool include_center)
static std::unique_ptr< Geometry > | MakeStrokedArc (const Rect &oval_bounds, Degrees start, Degrees sweep, const StrokeParameters &stroke)
static std::unique_ptr< Geometry > | MakeRoundRect (const Rect &rect, const Size &radii)
static std::unique_ptr< Geometry > | MakeRoundSuperellipse (const Rect &rect, Scalar corner_radius)
static Scalar | ComputeStrokeAlphaCoverage (const Matrix &entity, Scalar stroke_width)
| Compute an alpha value to simulate lower coverage of fractional pixel strokes. More...
static GeometryResult | ComputePositionGeometry (const ContentContext &renderer, const Tessellator::VertexGenerator &generator, const Entity &entity, RenderPass &pass)

## Detailed Description

Definition at line 13 of file rect_geometry.h.

## Constructor & Destructor Documentation

## ◆ FillRectGeometry()

impeller::FillRectGeometry::FillRectGeometry | ( | Rect | rect | ) |
| explicit

Definition at line 9 of file rect_geometry.cc.

9 : rect_(rect) {}

## ◆ ~FillRectGeometry()

impeller::FillRectGeometry::~FillRectGeometry | ( |  | ) |
| overridedefault

## Member Function Documentation

## ◆ CoversArea()

bool impeller::FillRectGeometry::CoversArea | ( | const Matrix & | transform,
|  | const Rect & | rect
| ) |  | const
| overridevirtual

Determines if this geometry, transformed by the given `transform`, will completely cover all surface area of the given `rect`.

This is a conservative estimate useful for certain optimizations.

Returns
  `true` if the transformed geometry is guaranteed to cover the given `rect`. May return `false` in many undetected cases where the transformed geometry does in fact cover the `rect`.

Reimplemented from impeller::Geometry.

Definition at line 37 of file rect_geometry.cc.

38 {
39 if (!transform.IsTranslationScaleOnly()) {
40 return false;
41 }
42 Rect coverage = rect_.TransformBounds(transform);
43 return coverage.Contains(rect);
44 }
transform
Matrix transform
Definition: gaussian_blur_filter_contents.cc:312
impeller::Rect
TRect< Scalar > Rect
Definition: rect.h:788
impeller::TRect::TransformBounds
constexpr TRect TransformBounds(const Matrix &transform) const
Creates a new bounding box that contains this transformed rectangle.
Definition: rect.h:472
impeller::TRect::Contains
constexpr bool Contains(const TPoint< Type > &p) const
Returns true iff the provided point |p| is inside the half-open interior of this rectangle.
Definition: rect.h:231

References impeller::TRect< T >::Contains(), transform, and impeller::TRect< T >::TransformBounds().

## ◆ GetCoverage()

std::optional< Rect > impeller::FillRectGeometry::GetCoverage | ( | const Matrix & | transform | ) | const
| overridevirtual

Implements impeller::Geometry.

Definition at line 32 of file rect_geometry.cc.

33 {
34 return rect_.TransformBounds(transform);
35 }

References transform, and impeller::TRect< T >::TransformBounds().

## ◆ GetPositionBuffer()

GeometryResult impeller::FillRectGeometry::GetPositionBuffer | ( | const ContentContext & | renderer,
|  | const Entity & | entity,
|  | RenderPass & | pass
| ) |  | const
| overridevirtual

Implements impeller::Geometry.

Definition at line 13 of file rect_geometry.cc.

16 {
17 auto& data_host_buffer = renderer.GetTransientsDataBuffer();
18 return GeometryResult{
19 .type = PrimitiveType::kTriangleStrip,
20 .vertex_buffer =
21 {
22 .vertex_buffer = data_host_buffer.Emplace(
23 rect_.GetPoints().data(), 8 * sizeof(float), alignof(float)),
24 .vertex_count = 4,
25 .index_type = IndexType::kNone,
26 },
27 .transform = entity.GetShaderTransform(pass),
28 .mode = GeometryResult::Mode::kNormal,
29 };
30 }
impeller::PrimitiveType::kTriangleStrip
@ kTriangleStrip
impeller::IndexType::kNone
@ kNone
Does not use the index buffer.
impeller::GeometryResult::Mode::kNormal
@ kNormal
The geometry has no overlapping triangles.
impeller::TRect::GetPoints
constexpr std::array< TPoint< T >, 4 > GetPoints() const
Get the points that represent the 4 corners of this rectangle in a Z order that is compatible with tr...
Definition: rect.h:414

References impeller::TRect< T >::GetPoints(), impeller::Entity::GetShaderTransform(), impeller::ContentContext::GetTransientsDataBuffer(), impeller::kNone, impeller::GeometryResult::kNormal, impeller::kTriangleStrip, and impeller::GeometryResult::type.

## ◆ IsAxisAlignedRect()

bool impeller::FillRectGeometry::IsAxisAlignedRect | ( |  | ) | const
| overridevirtual

Reimplemented from impeller::Geometry.

Definition at line 46 of file rect_geometry.cc.

46 {
47 return true;
48 }

The documentation for this class was generated from the following files:

- impeller/entity/geometry/rect_geometry.h
- impeller/entity/geometry/rect_geometry.cc